From f3ca5c939f9f976a0d756c47a56b7ed5a776d26a Mon Sep 17 00:00:00 2001
From: Sergey Bronnikov <sergeyb@tarantool.org>
Date: Fri, 21 Jun 2024 17:56:55 +0300
Subject: [PATCH] perf: add a script for setting environment

"Benchmarking" article [0] in Tarantool's wiki contains a lot of
recommendations that help to setup the Linux operating system and
avoid potential reproducibility pitfalls when executing
performance tests in a Linux-based environment. These
recommendations written in plain text with examples of commands
that could be executed manually. We desire to execute benchmarks
automatically and in continuous mode, therefore we need a way to
setup the test environment automatically before running
benchmarks.

There are many guides with benchmarking tips, but unfortunately
there is no script that will do these steps automatically.
I found only temci [1] and pyperf (`pyperf system` [2]) projects.

The patch adds a script for setting the environment before running
performance tests. All settings used in the proposed script are
described in the article [3]. Note, that uncertain settings were
not implemented.

0. https://github.com/tarantool/tarantool/wiki/Benchmarking
1. https://github.com/parttimenerd/temci
2. https://github.com/travisdowns/uarch-bench/blob/master/uarch-bench.sh
3. https://pyperf.readthedocs.io/en/latest/cli.html#system-cmd

NO_CHANGELOG=performance
NO_DOC=performance
NO_TEST=performance
---
 .github/workflows/perf_micro.yml |   2 +
 perf/tools/setup_env.sh          | 129 +++++++++++++++++++++++++++++++
 2 files changed, 131 insertions(+)
 create mode 100755 perf/tools/setup_env.sh

diff --git a/.github/workflows/perf_micro.yml b/.github/workflows/perf_micro.yml
index 99b9f4f523..26bd3929ad 100644
--- a/.github/workflows/perf_micro.yml
+++ b/.github/workflows/perf_micro.yml
@@ -74,6 +74,8 @@ jobs:
         with:
           submodule: ${{ inputs.submodule }}
           revision: ${{ inputs.revision }}
+      - name: setup environment
+        run: sh ./perf/tools/setup_env.sh
       - name: test
         run: make -f .test.mk test-perf
       - name: Aggregate benchmark results
diff --git a/perf/tools/setup_env.sh b/perf/tools/setup_env.sh
new file mode 100755
index 0000000000..bc0260e33a
--- /dev/null
+++ b/perf/tools/setup_env.sh
@@ -0,0 +1,129 @@
+#!/bin/sh
+
+# The script setting up a Linux operating system before running
+# Tarantool benchmarks, see [1].
+#
+# 1. https://github.com/tarantool/tarantool/wiki/Benchmarking
+
+set -eu
+
+uid=$(id -u)
+if [ "$uid" -ne 0 ]
+  then echo "Please run as root."
+  exit 1
+fi
+
+###
+# Helpers.
+###
+
+cpu_vendor="unknown"
+cpuinfo_vendor=$(awk '/vendor_id/{ print $3; exit }' < /proc/cpuinfo)
+if [ "$cpuinfo_vendor" = "GenuineIntel" ]; then
+   cpu_vendor="intel"
+elif [ "$cpuinfo_vendor" = "AuthenticAMD" ]; then
+   cpu_vendor="amd"
+else
+   echo "Unknown CPU vendor '$cpuinfo_vendor'"
+   exit 1
+fi
+
+FAILURE_MSG="WARNING"
+SUCCESS_MSG="CHECKED"
+SKIPPED_MSG="SKIPPED"
+
+set_kernel_setting() {
+  desc_msg="$1"
+  file_path="$2"
+  value="$3"
+
+  if [ -f "$file_path" ]; then
+    sh -c "echo $value > $file_path" && status="$SUCCESS_MSG" || status="$FAILURE_MSG"
+  else
+    status="$SKIPPED_MSG"
+  fi
+  echo "$desc_msg $status"
+}
+
+kernel_setting_is_nonzero() {
+  desc_msg="$1"
+  file_path="$2"
+  hint_msg="$3"
+
+  if [ -f "$file_path" ]; then
+    value=$(cat "$file_path")
+    if [ -n "$value" ]; then
+      status="$SUCCESS_MSG"
+    else
+      status="$FAILURE_MSG (hint: $hint_msg)"
+    fi
+  else
+    status="$SKIPPED_MSG"
+  fi
+  echo "$desc_msg $status"
+}
+
+###
+# Kernel command line parameters.
+###
+
+desc_msg="Disable AMD SMT or Intel Hyperthreading "
+sysfs_path="/sys/devices/system/cpu/smt/active"
+if [ -f "$sysfs_path" ]; then
+  is_set=$(cat $sysfs_path)
+  err_msg="$FAILURE_MSG (hint: set 'nosmt' kernel parameter)"
+  [ "$is_set" = 1 ] && status="$SUCCESS_MSG" || status="$err_msg"
+else
+  status="$SKIPPED_MSG"
+fi
+echo "$desc_msg $status"
+
+kernel_setting_is_nonzero \
+  "Isolate CPUs for benchmarking" \
+  "/sys/devices/system/cpu/isolated" \
+  "set 'isolcpus' kernel parameter"
+
+kernel_setting_is_nonzero \
+  "Offload interrupts from the isolated CPUs" \
+  "/proc/irq/default_smp_affinity" \
+  "set 'irqaffinity' kernel parameter"
+
+kernel_setting_is_nonzero \
+  "Disable scheduling on single-task isolated CPUs" \
+  "/sys/devices/system/cpu/nohz_full" \
+  "set 'nohz_full' kernel parameter"
+
+set_kernel_setting \
+  "Disable transparent huge pages" \
+  "/sys/kernel/mm/transparent_hugepage/enabled" \
+  "never"
+
+set_kernel_setting \
+  "Disable direct compaction of transparent huge pages" \
+  "/sys/kernel/mm/transparent_hugepage/defrag" \
+  "never"
+
+###
+# System tuning.
+###
+
+if [ "$cpu_vendor" = "amd" ]; then
+  sysfs_path="/sys/devices/system/cpu/cpufreq/boost"
+  value=0
+elif [ "$cpu_vendor" = "intel" ]; then
+  sysfs_path="/sys/devices/system/cpu/intel_pstate/no_turbo"
+  value=1
+fi
+set_kernel_setting \
+  "Disable TurboBoost" \
+  "$sysfs_path" \
+  "$value"
+
+ncpu=$(getconf _NPROCESSORS_ONLN)
+for cpu_id in $(seq 0 1 $((ncpu-1))); do
+  sysfs_path_cpu="/sys/devices/system/cpu/cpu$cpu_id/cpufreq/scaling_governor"
+  set_kernel_setting \
+    "Stabilize the frequency of CPU $cpu_id" \
+    "$sysfs_path_cpu" \
+    "performance"
+done
-- 
GitLab